
from batchcompute.utils.functions import ConfigError
from terminal import Logger, prompt, password

from ..services import config, client, printer

log = Logger()

def _setLoginConfig(key, value):
    config.setConfig(config.COMMON, key,value)

def _setLoginConfigs(opt):
    config.setConfigs(config.COMMON, opt)

def _getLoginConfigs():
    return config.getConfigs(config.COMMON, ['accesskeyid','accesskeysecret'])

def _removeLoginConfig(key):
    return config.removeConfig(config.COMMON, key)


def login(region,accessKeyId=None, accessKeySecret=None):
    opt = {}

    if '.' in region:
        opt['endpoint'] = region
    else:
        opt['region'] = region

    isLogin = False
    if region and accessKeyId and accessKeySecret:

        opt['accesskeyid'] = accessKeyId
        opt['accesskeysecret'] = accessKeySecret
        isLogin = True

    else:
        m = _getLoginConfigs()
        if m:
            opt['accesskeyid'] = m['accesskeyid']
            opt['accesskeysecret'] = m['accesskeysecret']
        else:
            opt['accesskeyid'] = prompt('input accessKeyId')
            opt['accesskeysecret'] = password('and accessKeySecret')

    try:
        client.check_client(opt)

        _setLoginConfigs(opt)

        printer.done('login success' if isLogin else 'Done')

    except ConfigError as e:
        raise ConfigError('Invalid region %s' % (region)) if opt.get('region') else e

